user www-data;
worker_processes auto;
pid /run/nginx.pid;
include /etc/nginx/modules-enabled/*.conf;

error_log  /var/log/nginx/general_error.log;
error_log  /var/log/nginx/general_error.log  notice;
error_log  /var/log/nginx/general_info.log  info;

events {
	worker_connections 1024;
	use epoll;
	# multi_accept on;
}

http {
	log_format  main  '$remote_addr - $remote_user [$time_local] "$request" '
                         '$status $body_bytes_sent "$http_referer" '
                          '"$http_user_agent" "$http_x_forwarded_for"';


        ##
        # Basic Settings
        ##

        sendfile on;
        tcp_nopush on;
        tcp_nodelay on;
        types_hash_max_size 2048;
        server_tokens off;
        client_body_buffer_size 20K;
        client_header_buffer_size 1k;
        client_max_body_size 50M;
        large_client_header_buffers 4 32k;

        client_body_timeout 300;
        client_header_timeout 300;
        keepalive_timeout 360;
        send_timeout 600;       


        server_names_hash_bucket_size 64;
        
        include /etc/nginx/mime.types;
        default_type application/octet-stream;

        ##
        # SSL Settings
        ##

        ssl_protocols TLSv1.3; 
        ssl_ciphers "EECDH+AESGCM:EDH+AESGCM:AES256+EECDH:AES256+EDH:@SECLEVEL=1";
        ssl_prefer_server_ciphers on;

	##
        # Logging Settings
        ##

        access_log /var/log/nginx/access.log;
        error_log /var/log/nginx/error.log;

        ##
        # Gzip Settings
        ##

        gzip on;
        gzip_vary on;
        gzip_min_length 1024;
        gzip_proxied expired no-cache no-store private auth;
        gzip_http_version 1.0;
        gzip_comp_level 2;
        gzip_proxied any;
        gzip_disable msie6;
        gzip_types text/plain text/css application/x-javascript text/xml application/xml application/xml+rss text/javascript application/json application/php;
        
        ##Security Settings
        # Clickjacking Attack
        add_header X-Frame-Options "SAMEORIGIN";
        # Clickjacking Attack
        add_header X-XSS-Protection "1; mode=block";
    
#       vhost_traffic_status_zone;

        ##
        # Common Upstream
        ##

    
        upstream  php_backend  {
                server   127.0.0.1:9000;
#               server   ${FPMURI};
#               server   backup.server:port2    backup;
        }

        ##
        # Virtual Host Configs
        ##

	include /etc/nginx/conf.d/*.conf;
	include /etc/nginx/sites-enabled/*.conf;
}

